    # Auto-generated by EclipseNSIS Script Wizard
    # Sep 1, 2012 12:00:50 AM
    
    Name "Catel.ReSharper"
    BrandingText 'Catel development team'
    
    #!define RESHARPER_BASE_DIR "$PROGRAMFILES\JetBrains\ReSharper"
    
    # General Symbol Definitions
    !define REGKEY "SOFTWARE\$(^Name)"
    !define VERSION 1.0.0.0
    !define COMPANY CatenaLogic
    !define URL http://catel.codeplex.com
    
    # MUI Symbol Definitions
    !define MUI_ICON "..\InnoSetup\template\resources\catel.ico"
    !define MUI_WELCOMEFINISHPAGE_BITMAP "..\InnoSetup\template\resources\logo_large.bmp"
    !define MUI_WELCOMEPAGE_TITLE "Welcome to the Catel.ReSharper v1.0.0.0 Setup"
    !define MUI_HEADERIMAGE_BITMAP "..\InnoSetup\template\resources\logo_small.bmp"
    !define MUI_FINISHPAGE_NOAUTOCLOSE
    
    # TODO: Detect the hightest visual studio at runtime.
    #!define MUI_FINISHPAGE_RUN "C:\Program Files (x86)\Microsoft Visual Studio 10.0\Common7\IDE\devenv.exe"
    #!define MUI_FINISHPAGE_RUN_TEXT "Visual Studio 2010"
    !define MUI_FINISHPAGE_TITLE "Completing the Catel.ReSharper v1.0.0.0 Setup"
    !define MUI_FINISHPAGE_SHOWREADME $INSTDIR\readme.txt
    
    !define MUI_UNICON "..\InnoSetup\template\resources\catel.ico"
    !define MUI_UNWELCOMEFINISHPAGE_BITMAP "..\InnoSetup\template\resources\logo_large.bmp"
    !define MUI_HEADERIMAGE_UNBITMAP "..\InnoSetup\template\resources\logo_small.bmp"
    !define MUI_UNFINISHPAGE_NOAUTOCLOSE
    
    # Included files
    !include LogicLib.nsh
    !include Sections.nsh
    !include MUI2.nsh
    
    # Variables
    
    
    # Messages
    !define DOT_NET_MISSING_MESSAGE "This setup requires the .NET framework. Please download and install the .NET framework and run this setup again.$\nDo you want to download the framework now?" 
    !define RESHARPER_MISSING_MESSAGE "This setup requires a version (v6.1, v7.0) of JetBrains ReSharper which is not found on this machine."
    
    # Installer pages
    !insertmacro MUI_PAGE_WELCOME
    !insertmacro MUI_PAGE_INSTFILES
    !insertmacro MUI_PAGE_FINISH
    !insertmacro MUI_UNPAGE_CONFIRM
    !insertmacro MUI_UNPAGE_INSTFILES
    
    # Installer languages
    !insertmacro MUI_LANGUAGE English
    
    # Installer attributes
    OutFile setup.exe
    InstallDir "$PROGRAMFILES\Catel\$(^Name)"
    CRCCheck on
    XPStyle on
    ShowInstDetails show
    VIProductVersion 1.0.0.0
    VIAddVersionKey ProductName "Catel.ReSharper"
    VIAddVersionKey ProductVersion "${VERSION}"
    VIAddVersionKey CompanyName "${COMPANY}"
    VIAddVersionKey CompanyWebsite "${URL}"
    VIAddVersionKey FileVersion "${VERSION}"
    VIAddVersionKey FileDescription ""
    VIAddVersionKey LegalCopyright ""
    InstallDirRegKey HKLM "${REGKEY}" Path
    ShowUninstDetails show
    
    # Installer sections
    Section -Main SEC0000
        SetOutPath $INSTDIR
        SetOverwrite on

        DetailPrint "Looking for JetBrains ReSharper installed versions"

        Push false
        Pop $3 

        Push "v6.1"
        Push "v7.0"
        Push "v7.1"
        Push "v8.0"
	${Do}
            Pop $0
            ReadRegStr $1 HKLM "Software\JetBrains\ReSharper\$0" InstallDir
            ${If} $1 != ''
                DetailPrint "Installing Catel.ReSharper for JetBrains ReSharper $0"
                SetOutPath "$1\Plugins\$(^Name)"
                ${If} $0 == 'v6.1'
                    File /r "..\..\output\Debug\v6.1\*.dll" 
                ${ElseIf} $0 == 'v7.0'
                    File /r "..\..\output\Debug\v7.0\*.dll" 
                ${ElseIf} $0 == 'v7.1'
                    File /r "..\..\output\Debug\v7.1\*.dll" 
                ${ElseIf} $0 == 'v8.0'
                    File /r "..\..\output\Debug\v8.0\*.dll" 
                ${EndIf}

                Push true
                Pop $3 
                WriteRegStr HKLM "${REGKEY}" "$0" 1
            ${EndIf}
        ${LoopUntil} $0 == "v6.1"  

        ${If} $3 == false
           MessageBox MB_OK "${RESHARPER_MISSING_MESSAGE}"
	       Abort        
        ${EndIf}   

        WriteRegStr HKLM "${REGKEY}\Components" Main 1
    SectionEnd
    
    Section -post SEC0001
        WriteRegStr HKLM "${REGKEY}" Path $INSTDIR
        SetOutPath $INSTDIR
        SetOverwrite on
        File ..\InnoSetup\template\readme.txt
        WriteUninstaller $INSTDIR\uninstall.exe
    SectionEnd
    
    # Macro for selecting uninstaller sections
    !macro SELECT_UNSECTION SECTION_NAME UNSECTION_ID
        Push $R0
        ReadRegStr $R0 HKLM "${REGKEY}\Components" "${SECTION_NAME}"
        StrCmp $R0 1 0 next${UNSECTION_ID}
        !insertmacro SelectSection "${UNSECTION_ID}"
        GoTo done${UNSECTION_ID}
    next${UNSECTION_ID}:
        !insertmacro UnselectSection "${UNSECTION_ID}"
    done${UNSECTION_ID}:
        Pop $R0
    !macroend
    
    # Uninstaller sections
    Section /o -un.Main UNSEC0000

        Push "v6.1"
        Push "v7.0"
        Push "v7.1"
        Push "v8.0"
	${Do}
            Pop $0
            ReadRegStr $1 HKLM "${REGKEY}" "$0"
            ${If} $1 == '1'
                ReadRegStr $2 HKLM "Software\JetBrains\ReSharper\$0" InstallDir
                ${If} $2 != ''
                    RMDir /r /REBOOTOK "$2\Plugins\$(^Name)" 
    		        DeleteRegValue HKLM "${REGKEY}" "$0"
    		    ${EndIf}
    	    ${EndIf}
        ${LoopUntil} $0 == "v6.1"
       
        DeleteRegValue HKLM "${REGKEY}\Components" Main
    SectionEnd
    
    Section -un.post UNSEC0001
        Delete /REBOOTOK $INSTDIR\readme.txt
        Delete /REBOOTOK $INSTDIR\uninstall.exe
        RMDir  /REBOOTOK $INSTDIR
        
        DeleteRegValue HKLM "${REGKEY}" Path
        
        DeleteRegKey /IfEmpty HKLM "${REGKEY}\Components"
        DeleteRegKey /IfEmpty HKLM "${REGKEY}"
    SectionEnd
    
    # Installer functions
    Function .onInit
        InitPluginsDir
        
        #TODO: Move to a macro
        ReadRegStr $1 HKLM "SOFTWARE\Microsoft\NET Framework Setup\NDP\v3.5" Version
        ${If} $1 == '' 
            MessageBox MB_YESNO|MB_ICONQUESTION "${DOT_NET_MISSING_MESSAGE}" IDNO Continue
            ExecShell "open" "http://www.microsoft.com/downloads/details.aspx?FamilyId=333325fd-ae52-4e35-b531-508d977d32a6&displaylang=en"
            Continue:
                Abort
        ${EndIf}
    FunctionEnd
    
    # Uninstaller functions
    Function un.onInit
        ReadRegStr $INSTDIR HKLM "${REGKEY}" Path
        
        !insertmacro SELECT_UNSECTION Main ${UNSEC0000}
    FunctionEnd
    
